> ## Documentation Index
> Fetch the complete documentation index at: https://docs.hanko.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Finish MFA Login

> Finalize the login operation



## OpenAPI

````yaml openapi-passkeys post /{tenant_id}/mfa/login/finalize
openapi: 3.1.0
info:
  version: '1.2'
  title: passkey-server
  description: >-
    This API shall represent the private and public endpoints for passkey
    registration, management and authentication
  termsOfService: https://www.hanko.io/terms
  contact:
    email: developers@hanko.io
    url: https://www.hanko.io
    name: Hanko Dev Team
  license:
    url: https://www.gnu.org/licenses/gpl-3.0.de.html
    name: GPLv3
servers:
  - url: https://passkeys.hanko.io
security: []
tags:
  - name: credentials
    description: Represents all objects which are related to WebAuthn credentials
  - name: mfa
    description: Represents all objects which are related to MFA in common
  - name: webauthn
    description: Represents all objects which are related to WebAuthn in common
  - name: audit_logs
    description: Represents all objects which are related to audit logs
paths:
  /{tenant_id}/mfa/login/finalize:
    post:
      tags:
        - credentials
        - mfa
      summary: Finish MFA Login
      description: Finalize the login operation
      operationId: post-mfa-login-finalize
      parameters:
        - $ref: '#/components/parameters/X-API-KEY'
        - name: tenant_id
          in: path
          description: Tenant ID
          required: true
          schema:
            type: string
      requestBody:
        $ref: '#/components/requestBodies/post-login-finalize'
      responses:
        '200':
          $ref: '#/components/responses/token'
        '400':
          $ref: '#/components/responses/error'
        '401':
          $ref: '#/components/responses/error'
        '404':
          $ref: '#/components/responses/error'
        '500':
          $ref: '#/components/responses/error'
      security: []
      servers:
        - url: https://passkeys.hanko.io
components:
  parameters:
    X-API-KEY:
      name: apiKey
      in: header
      description: Secret API key
      required: true
      schema:
        type: string
        minLength: 32
  requestBodies:
    post-login-finalize:
      content:
        application/json:
          schema:
            allOf:
              - $ref: '#/components/schemas/public-key-credential'
              - type: object
                properties:
                  response:
                    $ref: '#/components/schemas/autenticator-assertion-response'
                  clientExtensionResults:
                    type: object
                    properties:
                      appid:
                        type: boolean
                      appidExclude:
                        type: boolean
                      credProps:
                        type: object
                        properties:
                          rk:
                            type: boolean
                required:
                  - response
                  - clientExtensionResults
  responses:
    token:
      description: Example response
      content:
        application/json:
          schema:
            type: object
            properties:
              token:
                type: string
            minProperties: 1
    error:
      description: Error Response with detailed information
      content:
        application/json:
          schema:
            type: object
            properties:
              title:
                type: string
                example:
                  - explanatory title
              details:
                type: string
                example:
                  - Information which helps resolving the problem
              status:
                type: integer
  schemas:
    public-key-credential:
      title: public-key-credential
      allOf:
        - $ref: '#/components/schemas/credential'
        - type: object
          properties:
            rawId:
              type: string
            authenticatorAttachment:
              type: string
              enum:
                - cross-platform
                - platform
                - null
          required:
            - rawId
    autenticator-assertion-response:
      title: autenticator-assertion-response
      allOf:
        - $ref: '#/components/schemas/authenticator-response'
        - type: object
          properties:
            authenticatorData:
              type: string
            signature:
              type: string
            userHandle:
              type: string | null
          required:
            - authenticatorData
            - signature
    credential:
      type: object
      title: credential
      properties:
        id:
          type: string
        type:
          enum:
            - public-key
      required:
        - id
        - type
    authenticator-response:
      type: object
      title: authenticator-response
      properties:
        clientDataJSON:
          type: string
      required:
        - clientDataJSON

````